Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc	(revision 962)
@@ -369,34 +529,87 @@
 //G4cout << "Pprojectile with Q M: " << Pprojectile<<" "<<  Pprojectile.mag() << G4endl;
 //G4cout << "Ptarget     with Q M: " << Ptarget    <<" "<<  Ptarget.mag()     << G4endl;
-
-//G4cout << "Target	 mass  " <<  Ptarget.mag() << G4endl;     
-	   		   
+//G4cout << "Target	 mass  " <<  Ptarget.mag() << G4endl;
+//G4cout << "Projectile mass  " <<  Pprojectile.mag() << G4endl;
+
+/*
+if(!Flip){
+	   projectile->Set4Momentum(Pprojectile);
 	   target->Set4Momentum(Ptarget);
-
-//G4cout << "Projectile mass  " <<  Pprojectile.mag() << G4endl; 
+         }
+else     {
+           G4ParticleDefinition * t_Definition=projectile->GetDefinition();
+           projectile->SetDefinition(target->GetDefinition());
+           projectile->Set4Momentum(Ptarget);
+           target->SetDefinition(t_Definition);
+           target->Set4Momentum(Pprojectile);
+          }
+*/
+//
+/*
+if(G4UniformRand() < 1.) {
+           G4ParticleDefinition * t_Definition=projectile->GetDefinition();
+           projectile->SetDefinition(target->GetDefinition());
+           target->SetDefinition(t_Definition);
+}
+*/ // For flip, for HARP
+
+           G4double ZcoordinateOfCurrentInteraction = target->GetPosition().z();
+// It is assumed that nucleon z-coordinates are ordered on increasing -----------
+
+           G4double betta_z=projectile->Get4Momentum().pz()/projectile->Get4Momentum().e();
+
+           G4double ZcoordinateOfPreviousCollision=projectile->GetPosition().z();
+           if(projectile->GetSoftCollisionCount()==0) {
+              projectile->SetTimeOfCreation(0.);
+              target->SetTimeOfCreation(0.);
+              ZcoordinateOfPreviousCollision=ZcoordinateOfCurrentInteraction;
+           }
+           
+           G4ThreeVector thePosition(projectile->GetPosition().x(),
+                                     projectile->GetPosition().y(),
+                                     ZcoordinateOfCurrentInteraction);
+           projectile->SetPosition(thePosition);
+
+           G4double TimeOfPreviousCollision=projectile->GetTimeOfCreation();
+           G4double TimeOfCurrentCollision=TimeOfPreviousCollision+ 
+                    (ZcoordinateOfCurrentInteraction-ZcoordinateOfPreviousCollision)/betta_z; 
+
+           projectile->SetTimeOfCreation(TimeOfCurrentCollision);
+           target->SetTimeOfCreation(TimeOfCurrentCollision);
 
 	   projectile->Set4Momentum(Pprojectile);
+	   target->Set4Momentum(Ptarget);
+
+           projectile->IncrementCollisionCount(1);
+           target->IncrementCollisionCount(1);
+
+//
+//G4cout<<"Out of Excitation --------------------"<<G4endl;
+//G4int Uzhiinp; G4cin>>Uzhiinp;    // Vova
 
 	   return true;
 }
 
-
+// ---------------------------------------------------------------------
 G4ExcitedString * G4DiffractiveExcitation::
            String(G4VSplitableHadron * hadron, G4bool isProjectile) const
 {
+
+//G4cout<<"G4DiffractiveExcitation::String isProj"<<isProjectile<<G4endl;
+
 	hadron->SplitUp();
 	G4Parton *start= hadron->GetNextParton();
-	if ( start==NULL) 
+	if ( start==NULL)
 	{ G4cout << " G4FTFModel::String() Error:No start parton found"<< G4endl;
 	  return NULL;
 	}
 	G4Parton *end  = hadron->GetNextParton();
-	if ( end==NULL) 
+	if ( end==NULL)
 	{ G4cout << " G4FTFModel::String() Error:No end parton found"<< G4endl;
 	  return NULL;
 	}
-	
+
 	G4ExcitedString * string;
-	if ( isProjectile ) 
+	if ( isProjectile )
 	{
 		string= new G4ExcitedString(end,start, +1);
@@ -404,8 +617,51 @@
 		string= new G4ExcitedString(start,end, -1);
 	}
-	
+// Uzhi
+//G4cout<<"G4ExcitedString * G4DiffractiveExcitation::String"<<G4endl;
+//G4cout<<hadron->GetTimeOfCreation()<<" "<<hadron->GetPosition()/fermi<<G4endl;
+
+	string->SetTimeOfCreation(hadron->GetTimeOfCreation());
 	string->SetPosition(hadron->GetPosition());
 
 // momenta of string ends
+//
+        G4double Momentum=hadron->Get4Momentum().vect().mag();
+        G4double  Plus=hadron->Get4Momentum().e() + Momentum;
+        G4double Minus=hadron->Get4Momentum().e() - Momentum;
+
+        G4ThreeVector tmp;
+        if(Momentum > 0.) 
+        {
+         tmp.set(hadron->Get4Momentum().px(),
+                 hadron->Get4Momentum().py(),
+                 hadron->Get4Momentum().pz());
+         tmp/=Momentum;
+         }
+         else
+         {
+          tmp.set(0.,0.,1.);
+         };
+
+        G4LorentzVector Pstart(tmp,0.);
+        G4LorentzVector   Pend(tmp,0.);
+
+        if(isProjectile)
+        {
+         Pstart*=(-1.)*Minus/2.;
+         Pend  *=(+1.)*Plus /2.;
+         } 
+        else
+         {
+          Pstart*=(+1.)*Plus/2.;
+          Pend  *=(-1.)*Minus/2.;
+         };
+
+         Momentum=-Pstart.mag();
+         Pstart.setT(Momentum);  // It is assumed that quark has m=0.
+
+         Momentum=-Pend.mag();
+         Pend.setT(Momentum);    // It is assumed that di-quark has m=0.
+//
+/* Uzhi
 	G4double ptSquared= hadron->Get4Momentum().perp2();
 	G4double transverseMassSquared= hadron->Get4Momentum().plus()
@@ -416,5 +672,5 @@
 		 sqr( std::sqrt(transverseMassSquared) - std::sqrt(ptSquared) );
 
-        G4double widthOfPtSquare = 0.25;          // Uzhi <Pt^2>=0.25 ??????????????????
+        G4double widthOfPtSquare = 0.25*GeV*GeV;       // Uzhi 11.07 <Pt^2>=0.25 ??????????????????
 	G4ThreeVector pt=GaussianPt(widthOfPtSquare,maxAvailMomentumSquared);
 
@@ -432,5 +688,5 @@
 
 	G4int Sign= isProjectile ? -1 : 1;
-	
+
 	G4double endMinus  = 0.5 * (tm1 + Sign*tm2);
 	G4double startMinus= hadron->Get4Momentum().minus() - endMinus;
@@ -444,17 +700,30 @@
 	Pend.setPz(0.5*(endPlus - endMinus));
 	Pend.setE(0.5*(endPlus + endMinus));
-
+*/ // Uzhi
 	start->Set4Momentum(Pstart);
 	end->Set4Momentum(Pend);
-	
+/*
+G4cout<<"G4DiffractiveExcitation::String hadro"<<hadron->Get4Momentum()<<" "<<hadron->Get4Momentum().mag2()<<G4endl;
+
+G4cout<<"G4DiffractiveExcitation::String start"<<start->Get4Momentum()<<" "<<start->GetPDGcode()<<G4endl;
+
+G4cout<<"G4DiffractiveExcitation::String end  "<<  end->Get4Momentum()<<" "<<  end->GetPDGcode()<<G4endl;
+G4int Uzhi; G4cin>>Uzhi;
+*/
 #ifdef G4_FTFDEBUG
-	G4cout << " generated string flavors          " << start->GetPDGcode() << " / " << end->GetPDGcode() << G4endl;
-	G4cout << " generated string momenta:   quark " << start->Get4Momentum() << "mass : " <<start->Get4Momentum().mag()<< G4endl;
-	G4cout << " generated string momenta: Diquark " << end ->Get4Momentum() << "mass : " <<end->Get4Momentum().mag()<< G4endl;
+	G4cout << " generated string flavors          " 
+               << start->GetPDGcode() << " / " 
+               << end->GetPDGcode()                    << G4endl;
+	G4cout << " generated string momenta:   quark " 
+               << start->Get4Momentum() << "mass : " 
+               <<start->Get4Momentum().mag()           << G4endl;
+	G4cout << " generated string momenta: Diquark " 
+               << end ->Get4Momentum() 
+               << "mass : " <<end->Get4Momentum().mag()<< G4endl;
 	G4cout << " sum of ends                       " << Pstart+Pend << G4endl;
 	G4cout << " Original                          " << hadron->Get4Momentum() << G4endl;
 #endif
-	
-	return string;	
+
+	return string;
 }
 
@@ -462,13 +731,13 @@
 // --------- private methods ----------------------
 
+// ---------------------------------------------------------------------
 G4double G4DiffractiveExcitation::ChooseP(G4double Pmin, G4double Pmax) const // Uzhi
 {
 // choose an x between Xmin and Xmax with P(x) ~ 1/x
-
 //  to be improved...
 
 	G4double range=Pmax-Pmin;                                         // Uzhi
-	
-	if ( Pmin <= 0. || range <=0. ) 
+
+	if ( Pmin <= 0. || range <=0. )
 	{
 		G4cout << " Pmin, range : " << Pmin << " , " << range << G4endl;
@@ -489,7 +758,9 @@
 }
 
-G4ThreeVector G4DiffractiveExcitation::GaussianPt(G4double AveragePt2, G4double maxPtSquare) const // Uzhi
+// ---------------------------------------------------------------------
+G4ThreeVector G4DiffractiveExcitation::GaussianPt(G4double AveragePt2, 
+                                                  G4double maxPtSquare) const // Uzhi
 {            //  @@ this method is used in FTFModel as well. Should go somewhere common!
-	
+
 	G4double Pt2;
 /*                                                                          // Uzhi
@@ -499,13 +770,15 @@
 */                                                                          // Uzhi
 
-        Pt2 = -AveragePt2 * std::log(1. + G4UniformRand() * (std::exp(-maxPtSquare/AveragePt2)-1.));// Uzhi 
-	
+        Pt2 = -AveragePt2 * std::log(1. + G4UniformRand() * 
+                           (std::exp(-maxPtSquare/AveragePt2)-1.));// Uzhi
+
 	G4double Pt=std::sqrt(Pt2);
 
 	G4double phi=G4UniformRand() * twopi;
-	
-	return G4ThreeVector (Pt*std::cos(phi), Pt*std::sin(phi), 0.);    
-}
-
+
+	return G4ThreeVector (Pt*std::cos(phi), Pt*std::sin(phi), 0.);
+}
+
+// ---------------------------------------------------------------------
 G4DiffractiveExcitation::G4DiffractiveExcitation(const G4DiffractiveExcitation &)
 {
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveHHScatterer.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveHHScatterer.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveHHScatterer.cc	(revision 962)
@@ -30,4 +30,5 @@
 #include "G4KineticTrack.hh"
 #include "G4DiffractiveSplitableHadron.hh"
+#include "G4FTFParameters.hh"                            // Uzhi 21.04.08
 
 G4DiffractiveHHScatterer::G4DiffractiveHHScatterer()
@@ -37,4 +38,5 @@
 {}
 
+// -------------------------------------------------------------------
 G4KineticTrackVector * G4DiffractiveHHScatterer::
 Scatter(const G4KineticTrack & aTrack, const G4KineticTrack & bTrack)
@@ -44,5 +46,10 @@
   G4DiffractiveSplitableHadron aHadron(& aTrack);
   G4DiffractiveSplitableHadron bHadron(& bTrack);
-  if ( ! theExcitation->ExciteParticipants(& aHadron, & bHadron)) 
+  theParameters = new G4FTFParameters(aHadron.GetDefinition(), // -------- Uzhi 21.04.08
+                                          1.,1., 100.);
+                                          //s);// ------------------------- Uzhi 21.04.08
+  if ( ! theExcitation->ExciteParticipants(& aHadron, 
+                                           & bHadron, 
+                                           theParameters))     // -------- Uzhi 21.04.08
   {
 	return NULL;
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveSplitableHadron.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveSplitableHadron.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveSplitableHadron.cc	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4DiffractiveSplitableHadron.cc,v 1.6 2006/06/29 20:54:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4DiffractiveSplitableHadron.cc,v 1.7 2008/03/31 15:34:01 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFModel.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFModel.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFModel.cc	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4FTFModel.cc,v 1.7 2007/04/24 10:32:59 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4FTFModel.cc,v 1.13 2008/12/09 10:40:52 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
@@ -38,4 +38,5 @@
 
 #include "G4FTFModel.hh"
+#include "G4FTFParameters.hh"                            // Uzhi 29.03.08
 #include "G4FTFParticipants.hh"
 #include "G4InteractionContent.hh"
@@ -43,13 +44,17 @@
 #include "G4ParticleDefinition.hh"
 #include "G4ios.hh"
+#include <utility>                                        // Uzhi 29.03.08
 
 // Class G4FTFModel 
 
-G4FTFModel::G4FTFModel():theExcitation(new G4DiffractiveExcitation()) // Uzhi
+G4FTFModel::G4FTFModel():theExcitation(new G4DiffractiveExcitation()),
+                         theElastic(new G4ElasticHNScattering()) // Uzhi 29.03.08
 {
 	G4VPartonStringModel::SetThisPointer(this);
-}
-
-G4FTFModel::G4FTFModel(G4double a, G4double b, G4double c):theExcitation(new G4DiffractiveExcitation())
+        theParameters=0;                                         // Uzhi 9.12.08
+}
+
+/*
+G4FTFModel::G4FTFModel(G4double , G4double , G4double ):theExcitation(new // Uzhi 9.12.08 G4DiffractiveExcitation())
 {
 	G4VPartonStringModel::SetThisPointer(this);
@@ -62,9 +67,16 @@
 	G4VPartonStringModel::SetThisPointer(this);
 }
-
+*/
 
 
 G4FTFModel::~G4FTFModel()
-{}
+{
+   if( theParameters != 0 ) delete theParameters;             // Uzhi 5.12.08
+// Because FTF model can be called for various particles
+// theParameters must be erased at the end of each call.
+// Thus the delete is olso in G4FTFModel::GetStrings() method
+   if( theExcitation != 0 ) delete theExcitation;             // Uzhi 5.12.08
+   if( theElastic    != 0 ) delete theElastic;                // Uzhi 5.12.08
+}
 
 
@@ -86,85 +98,91 @@
 }
 
+// ------------------------------------------------------------
 void G4FTFModel::Init(const G4Nucleus & aNucleus, const G4DynamicParticle & aProjectile)
 {
-	theParticipants.Init(aNucleus.GetN(),aNucleus.GetZ()); // Uzhi N-mass number Z-charge
- 
 	theProjectile = aProjectile;  
-}
-
+//G4cout<<"G4FTFModel::Init "<<aNucleus.GetN()<<" "<<aNucleus.GetZ()<<G4endl;
+	theParticipants.Init(aNucleus.GetN(),aNucleus.GetZ()); 
+// Uzhi N-mass number Z-charge ------------------------- Uzhi 29.03.08
+
+// --- cms energy
+
+        G4double s = sqr( theProjectile.GetMass() ) +
+                     sqr( G4Proton::Proton()->GetPDGMass() ) +
+                     2*theProjectile.GetTotalEnergy()*G4Proton::Proton()->GetPDGMass();
+/*
+G4cout << " primary Total E (GeV): " << theProjectile.GetTotalEnergy()/GeV << G4endl;
+G4cout << " primary Mass    (GeV): " << theProjectile.GetMass() /GeV << G4endl;
+G4cout << "cms std::sqrt(s) (GeV) = " << std::sqrt(s) / GeV << G4endl;
+*/
+
+      if( theParameters != 0 ) delete theParameters;                    // Uzhi 9.12.08
+      theParameters = new G4FTFParameters(theProjectile.GetDefinition(),
+                                          aNucleus.GetN(),aNucleus.GetZ(),
+                                          s);// ------------------------- Uzhi 19.04.08
+//theParameters->SetProbabilityOfElasticScatt(0.); // To turn on/off (1/0) elastic scattering
+}
+
+// ------------------------------------------------------------
 G4ExcitedStringVector * G4FTFModel::GetStrings()
 {
-	theParticipants.BuildInteractions(theProjectile);
-
+//G4cout<<"theParticipants.GetList"<<G4endl;
+	theParticipants.GetList(theProjectile,theParameters);
+//G4cout<<"ExciteParticipants()"<<G4endl;
 	if (! ExciteParticipants()) return NULL;;
-
+//G4cout<<"theStrings = BuildStrings()"<<G4endl;
 	G4ExcitedStringVector * theStrings = BuildStrings();
-
+//G4cout<<"Return to theStrings "<<G4endl;
+        if( theParameters != 0 )                              // Uzhi 9.12.08 
+        {                                                     // Uzhi 9.12.08
+          delete theParameters;                               // Uzhi 9.12.08
+          theParameters=0;                                    // Uzhi 9.12.08
+        }                                                     // Uzhi 9.12.08
 	return theStrings;
 }
 
+// ------------------------------------------------------------
 struct DeleteVSplitableHadron { void operator()(G4VSplitableHadron * aH){delete aH;} };
 
-G4ExcitedStringVector * G4FTFModel::BuildStrings()
-{	
-
-// Loop over all collisions; find all primaries, and all target ( targets may 
-//  be duplicate in the List ( to unique G4VSplitableHadrons)
-
-	G4ExcitedStringVector * strings;
-	strings = new G4ExcitedStringVector();
-	
-	std::vector<G4VSplitableHadron *> primaries;
-	std::vector<G4VSplitableHadron *> targets;
-	
-	theParticipants.StartLoop();    // restart a loop 
-	while ( theParticipants.Next() ) 
-	{
-	    const G4InteractionContent & interaction=theParticipants.GetInteraction();
-                 //  do not allow for duplicates ...
-	    if ( primaries.end() == std::find(primaries.begin(), primaries.end(), interaction.GetProjectile()) )
-	    	primaries.push_back(interaction.GetProjectile());
-		
-	    if ( targets.end() == std::find(targets.begin(), targets.end(),interaction.GetTarget()) ) 
-	    	targets.push_back(interaction.GetTarget());
-	}
-	    
-	
-//	G4cout << "BuildStrings prim/targ " << primaries.entries() << " , " <<
-//					     targets.entries() << G4endl;
-
-
-	unsigned int ahadron;
-	for ( ahadron=0; ahadron < primaries.size() ; ahadron++)
-	{
-	    G4bool isProjectile=true;
-	    strings->push_back(theExcitation->String(primaries[ahadron], isProjectile));
-	}
-	for ( ahadron=0; ahadron < targets.size() ; ahadron++)
-	{
-	    G4bool isProjectile=false;
-	    strings->push_back(theExcitation->String(targets[ahadron], isProjectile));
-	}
-
-	std::for_each(primaries.begin(), primaries.end(), DeleteVSplitableHadron());
-	primaries.clear();
-	std::for_each(targets.begin(), targets.end(), DeleteVSplitableHadron());
-	targets.clear();
-	
-	return strings;
-}
-
+// ------------------------------------------------------------
 G4bool G4FTFModel::ExciteParticipants()
 {
-	
+/*    // Uzhi 29.03.08                     For elastic Scatt.
+G4cout<<"  In ExciteParticipants() "<<theParticipants.theInteractions.size()<<G4endl;
+G4cout<<" test Params Tot "<<theParameters->GetTotalCrossSection()<<G4endl;
+G4cout<<" test Params Ela "<<theParameters->GetElasticCrossSection()<<G4endl;
+	
+G4int counter=0;
+*/   // Uzhi 29.03.08
+
+
+
 	while (theParticipants.Next())
 	{	   
 	   const G4InteractionContent & collision=theParticipants.GetInteraction();
-
-//G4cout << " soft colls : " << collision.GetNumberOfSoftCollisions() << G4endl; // Uzhi no match
+/*
+counter++;
+G4cout<<" Inter # "<<counter<<G4endl;
+*/
 	   G4VSplitableHadron * projectile=collision.GetProjectile();
 	   G4VSplitableHadron * target=collision.GetTarget();
 
-	   if ( ! theExcitation->ExciteParticipants(projectile, target) ) 
+//   // Uzhi 29.03.08
+           G4bool Successfull;
+           if(G4UniformRand()< theParameters->GetProbabilityOfElasticScatt())
+           {
+//G4cout<<"Elastic"<<G4endl;
+            Successfull=theElastic->ElasticScattering(projectile, target, theParameters);
+           }
+           else
+           {
+//G4cout<<"Inelastic"<<G4endl;
+            Successfull=theExcitation->ExciteParticipants(projectile, target, theParameters);
+           }
+//           if(!Successfull)
+// // Uzhi 29.03.08
+
+//	   if ( ! theExcitation->ExciteParticipants(projectile, target) ) 
+           if(!Successfull)
 	   {
 //           give up, clean up
@@ -176,8 +194,10 @@
 		    const G4InteractionContent & interaction=theParticipants.GetInteraction();
                 	 //  do not allow for duplicates ...
-		    if ( primaries.end() == std::find(primaries.begin(), primaries.end(), interaction.GetProjectile()) )
+		    if ( primaries.end() == std::find(primaries.begin(), primaries.end(),
+                                                      interaction.GetProjectile()) )
 	    		primaries.push_back(interaction.GetProjectile());
 
-		    if ( targets.end() == std::find(targets.begin(), targets.end(),interaction.GetTarget()) ) 
+		    if ( targets.end()   == std::find(targets.begin(), targets.end(),
+                                                      interaction.GetTarget()) ) 
 	    		targets.push_back(interaction.GetTarget());
 		}
@@ -188,7 +208,62 @@
 
 	   	return false;
-	   }
-
+	   }  // End of the loop Uzhi
+        }
+	return true;
+}
+// ------------------------------------------------------------
+G4ExcitedStringVector * G4FTFModel::BuildStrings()
+{	
+// Loop over all collisions; find all primaries, and all target ( targets may 
+//  be duplicate in the List ( to unique G4VSplitableHadrons)
+
+	G4ExcitedStringVector * strings;
+	strings = new G4ExcitedStringVector();
+	
+	std::vector<G4VSplitableHadron *> primaries;
+	std::vector<G4VSplitableHadron *> targets;
+	
+	theParticipants.StartLoop();    // restart a loop 
+	while ( theParticipants.Next() ) 
+	{
+	    const G4InteractionContent & interaction=theParticipants.GetInteraction();
+                 //  do not allow for duplicates ...
+	    if ( primaries.end() == std::find(primaries.begin(), primaries.end(),
+                                                interaction.GetProjectile()) )
+	    	primaries.push_back(interaction.GetProjectile());
+		
+	    if ( targets.end()   == std::find(targets.begin(), targets.end(),
+                                                interaction.GetTarget()) ) 
+	    	targets.push_back(interaction.GetTarget());
 	}
-	return true;
-}
+	    
+	
+//	G4cout << "BuildStrings prim/targ " << primaries.size() << " , " <<
+//					       targets.size() << G4endl;
+
+	unsigned int ahadron;
+// Only for hA-interactions Uzhi -------------------------------------
+	for ( ahadron=0; ahadron < primaries.size() ; ahadron++)
+	{
+//G4ThreeVector aPosition=primaries[ahadron]->GetPosition();
+//G4cout<<"Proj Build "<<aPosition<<" "<<primaries[ahadron]->GetTimeOfCreation()<<G4endl;
+	    G4bool isProjectile=true;
+	    strings->push_back(theExcitation->String(primaries[ahadron], isProjectile));
+	}
+
+	for ( ahadron=0; ahadron < targets.size() ; ahadron++)
+	{
+//G4ThreeVector aPosition=targets[ahadron]->GetPosition();
+//G4cout<<"Targ Build "<<aPosition<<" "<<targets[ahadron]->GetTimeOfCreation()<<G4endl;
+	    G4bool isProjectile=false;
+	    strings->push_back(theExcitation->String(targets[ahadron], isProjectile));
+	}
+
+	std::for_each(primaries.begin(), primaries.end(), DeleteVSplitableHadron());
+	primaries.clear();
+	std::for_each(targets.begin(), targets.end(), DeleteVSplitableHadron());
+	targets.clear();
+	
+	return strings;
+}
+// ------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParticipants.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParticipants.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParticipants.cc	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4FTFParticipants.cc,v 1.7 2007/04/24 10:33:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4FTFParticipants.cc,v 1.9 2008/06/13 12:49:23 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // ------------------------------------------------------------
@@ -38,16 +38,12 @@
 // ------------------------------------------------------------
 
+#include "G4FTFParameters.hh"                            // Uzhi 29.03.08
 #include "G4FTFParticipants.hh"
 #include "G4DiffractiveSplitableHadron.hh"
 #include "G4VSplitableHadron.hh"
-//#include "G4PomeronCrossSection.hh"                      // Uzhi
-#include "G4FTFCrossSection.hh"                            // Uzhi
 #include "Randomize.hh"
-#include <utility>
-
+#include <utility>                                        // Uzhi 29.03.08
 
 // Class G4FTFParticipants 
-
-
 
 G4FTFParticipants::G4FTFParticipants() 
@@ -75,5 +71,6 @@
 //{}
 
-void G4FTFParticipants::BuildInteractions(const G4ReactionProduct  &thePrimary)
+void G4FTFParticipants::GetList(const G4ReactionProduct  &thePrimary,
+                                      G4FTFParameters    *theParameters) // Uzhi 29.03.08
 {
     
@@ -83,25 +80,11 @@
     theInteractions.clear();
 
-// --- cms energy
-
-    G4double s = sqr( thePrimary.GetMass() ) +
-		 sqr( G4Proton::Proton()->GetPDGMass() ) +
-		 2*thePrimary.GetTotalEnergy()*G4Proton::Proton()->GetPDGMass();
-
-//    G4cout << " primary Total E (GeV): " << thePrimary.GetTotalEnergy()/GeV << G4endl;
-//    G4cout << " primary Mass    (GeV): " << thePrimary.GetMass() /GeV << G4endl;
-//    G4cout << "cms std::sqrt(s) (GeV) = " << std::sqrt(s) / GeV << G4endl;
-
-//    G4PomeronCrossSection theCrossSection(thePrimary.GetDefinition());      // Uzhi
-      G4FTFCrossSection theCrossSection(thePrimary.GetDefinition(),s);        // Uzhi
-    
-
-    G4double deltaxy=2 * fermi; 
+    G4double deltaxy=2 * fermi;                       // Extra nuclear radius
 
     G4VSplitableHadron * primarySplitable=new G4DiffractiveSplitableHadron(thePrimary);
 
-    G4double xyradius;
-    xyradius =theNucleus->GetOuterRadius() + deltaxy;
-
+    G4double xyradius;                          
+    xyradius =theNucleus->GetOuterRadius() + deltaxy; // Impact parameter sampling
+                                                      // radius
     G4bool nucleusNeedsShift = true;
     
@@ -115,12 +98,16 @@
 	theNucleus->StartLoop();
 	G4Nucleon * nucleon;
-	while ( (nucleon=theNucleus->GetNextNucleon()) )
+//G4int InterNumber=0;           // Uzhi
+//while ( (nucleon=theNucleus->GetNextNucleon())&& (InterNumber < 1) ) // Uzhi
+	while ( (nucleon=theNucleus->GetNextNucleon()) ) // Uzhi
 	{
     	   G4double impact2= sqr(impactX - nucleon->GetPosition().x()) +
-    		    sqr(impactY - nucleon->GetPosition().y());
-//	   if ( theCrossSection.GetInelasticProbability(s,impact2)                       // Uzhi
-	   if ( theCrossSection.GetInelasticProbability(  impact2/fermi/fermi)           // Uzhi 
+                             sqr(impactY - nucleon->GetPosition().y());
+
+//	   if ( theParameters->GetInelasticProbability(impact2/fermi/fermi) // Uzhi 29.03.08 
+	   if ( theParameters->GetProbabilityOfInteraction(impact2/fermi/fermi) // Uzhi 29.03.08 
 		> G4UniformRand() )
 	   {
+//InterNumber++;
 	   	if ( nucleusNeedsShift ) 
 	   	{			// on the first hit, shift nucleus 
@@ -136,5 +123,6 @@
 	   	    nucleon->Hit(targetSplitable);
 	   	}
-	   	G4InteractionContent * aInteraction = new G4InteractionContent(primarySplitable);
+	   	G4InteractionContent * aInteraction = 
+                                       new G4InteractionContent(primarySplitable);
 		aInteraction->SetTarget(targetSplitable);
 		theInteractions.push_back(aInteraction);
@@ -152,7 +140,2 @@
 
 // Implementation (private) methods
-
-
-
-
-
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4ExcitedStringDecay.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4ExcitedStringDecay.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4ExcitedStringDecay.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ExcitedStringDecay.hh,v 1.7 2007/05/03 22:06:17 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4ExcitedStringDecay_h
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4FragmentingString.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4FragmentingString.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4FragmentingString.hh	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4FragmentingString.hh,v 1.3 2006/06/29 20:54:44 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4FragmentingString.hh,v 1.4 2007/12/20 15:38:06 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
@@ -58,5 +58,7 @@
 			  G4ParticleDefinition * newdecay,
 			  const G4LorentzVector *momentum);
-
+      G4FragmentingString(const G4FragmentingString &old,      // Uzhi
+			  G4ParticleDefinition * newdecay);    // Uzhi
+			  
       ~G4FragmentingString();
 
@@ -77,5 +79,5 @@
       G4double Mass() const;
       G4double Mass2() const;
-      
+      G4double MassT2() const;
       
       G4ParticleDefinition* GetLeftParton(void) const;
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronBuilder.hh,v 1.3 2006/06/29 20:54:46 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // -----------------------------------------------------------------------------
